use juno_build::JunoCompiler;

fn main() {
    #[cfg(not(feature = "cuda"))]
    {
        JunoCompiler::new()
            .file_in_src("conv.jn")
            .unwrap()
            .schedule_in_src("cpu.sch")
            .unwrap()
            .build()
            .unwrap();
    }
    #[cfg(feature = "grape")]
    {
        JunoCompiler::new()
            .file_in_src("conv.jn")
            .unwrap()
            .schedule_in_src("grape.sch")
            .unwrap()
            .build()
            .unwrap();
    }

    #[cfg(feature = "cuda")]
    {
        JunoCompiler::new()
            .file_in_src("simple.jn")
            .unwrap()
            .schedule_in_src("gpu.sch")
            .unwrap()
            .build()
            .unwrap();
    }
}
